# Generated by the protocol buffer compiler.  DO NOT EDIT!
# Source: dapr/proto/runtime/v1/dapr.proto for package 'dapr.proto.runtime.v1'
# Original file comments:
# ------------------------------------------------------------
# Copyright (c) Microsoft Corporation and Dapr Contributors.
# Licensed under the MIT License.
# ------------------------------------------------------------
#

require 'grpc'
require 'dapr/proto/runtime/v1/dapr_pb'

module Dapr
  module Proto
    module Runtime
      module V1
        module Dapr
          # Dapr service provides APIs to user application to access Dapr building blocks.
          class Service

            include GRPC::GenericService

            self.marshal_class_method = :encode
            self.unmarshal_class_method = :decode
            self.service_name = 'dapr.proto.runtime.v1.Dapr'

            # Invokes a method on a remote Dapr app.
            rpc :InvokeService, InvokeServiceRequest, ::Dapr::Proto::Common::V1::InvokeResponse
            # Gets the state for a specific key.
            rpc :GetState, GetStateRequest, GetStateResponse
            # Gets a bulk of state items for a list of keys
            rpc :GetBulkState, GetBulkStateRequest, GetBulkStateResponse
            # Saves the state for a specific key.
            rpc :SaveState, SaveStateRequest, Google::Protobuf::Empty
            # Deletes the state for a specific key.
            rpc :DeleteState, DeleteStateRequest, Google::Protobuf::Empty
            # Deletes a bulk of state items for a list of keys
            rpc :DeleteBulkState, DeleteBulkStateRequest, Google::Protobuf::Empty
            # Executes transactions for a specified store
            rpc :ExecuteStateTransaction, ExecuteStateTransactionRequest, Google::Protobuf::Empty
            # Publishes events to the specific topic.
            rpc :PublishEvent, PublishEventRequest, Google::Protobuf::Empty
            # Invokes binding data to specific output bindings
            rpc :InvokeBinding, InvokeBindingRequest, InvokeBindingResponse
            # Gets secrets from secret stores.
            rpc :GetSecret, GetSecretRequest, GetSecretResponse
            # Gets a bulk of secrets
            rpc :GetBulkSecret, GetBulkSecretRequest, GetBulkSecretResponse
            # Register an actor timer.
            rpc :RegisterActorTimer, RegisterActorTimerRequest, Google::Protobuf::Empty
            # Unregister an actor timer.
            rpc :UnregisterActorTimer, UnregisterActorTimerRequest, Google::Protobuf::Empty
            # Register an actor reminder.
            rpc :RegisterActorReminder, RegisterActorReminderRequest, Google::Protobuf::Empty
            # Unregister an actor reminder.
            rpc :UnregisterActorReminder, UnregisterActorReminderRequest, Google::Protobuf::Empty
            # Gets the state for a specific actor.
            rpc :GetActorState, GetActorStateRequest, GetActorStateResponse
            # Executes state transactions for a specified actor
            rpc :ExecuteActorStateTransaction, ExecuteActorStateTransactionRequest, Google::Protobuf::Empty
            # InvokeActor calls a method on an actor.
            rpc :InvokeActor, InvokeActorRequest, InvokeActorResponse
            # Gets metadata of the sidecar
            rpc :GetMetadata, Google::Protobuf::Empty, GetMetadataResponse
            # Sets value in extended metadata of the sidecar
            rpc :SetMetadata, SetMetadataRequest, Google::Protobuf::Empty
            # Shutdown the sidecar
            rpc :Shutdown, Google::Protobuf::Empty, Google::Protobuf::Empty
          end

          Stub = Service.rpc_stub_class
        end
      end
    end
  end
end
